Index: src/main/java/com/xpn/xwiki/plugin/lucene/LucenePlugin.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/lucene/LucenePlugin.java	(revision 25374)
+++ src/main/java/com/xpn/xwiki/plugin/lucene/LucenePlugin.java	(working copy)
@@ -507,15 +551,15 @@
 
     public void flushCache(XWikiContext context)
     {
-        Utils.getComponent(ObservationManager.class).removeListener(indexUpdater.getName());
+        Utils.getComponent(ObservationManager.class).removeListener(this.indexUpdater.getName());
 
-        indexRebuilder = null;
+        this.indexRebuilder = null;
 
         try {
             // set the thread to exit
-            indexUpdater.doExit();
+            this.indexUpdater.doExit();
             // wait for the thread to finish
-            indexUpdaterThread.join();
+            this.indexUpdaterThread.join();
         } catch (InterruptedException ex) {
             LOG.warn("Error while waiting for indexUpdaterThread to die.", ex);
         }
@@ -526,8 +570,8 @@
             LOG.warn("cannot close searchers", e);
         }
 
-        indexUpdater = null;
-        analyzer = null;
+        this.indexUpdater = null;
+        this.analyzer = null;
 
         init(context);
     }
@@ -548,21 +592,29 @@
      * @param indexDirs Comma separated list of Lucene index directories to create searchers for.
      * @return Array of searchers
      */
-    public Searcher[] createSearchers(String indexDirs) throws Exception
+    public Searcher[] createSearchers(String indexDirs, XWikiContext context) throws Exception
     {
         String[] dirs = StringUtils.split(indexDirs, ",");
         List<IndexSearcher> searchersList = new ArrayList<IndexSearcher>();
         for (int i = 0; i < dirs.length; i++) {
-            try {
-                if (!IndexReader.indexExists(dirs[i])) {
-                    // If there's no index there, create an empty one; otherwise the reader
-                    // constructor will throw an exception and fail to initialize
-                    new IndexWriter(dirs[i], analyzer).close();
+            RETRY: while (true) {
+                try {
+                    try {
+                        if (!IndexReader.indexExists(dirs[i])) {
+                            // If there's no index there, create an empty one; otherwise the reader
+                            // constructor will throw an exception and fail to initialize
+                            new IndexWriter(dirs[i], analyzer).close();
+                        }
+                        IndexReader reader = IndexReader.open(dirs[i], true);
+                        searchersList.add(new IndexSearcher(reader));
+                        break RETRY;
+                    } catch (CorruptIndexException e) {
+                        handleCorruptIndex(context);
+                    }
+                } catch (IOException e) {
+                    LOG.error("cannot open index " + dirs[i], e);
+                    throw new RuntimeException(e);
                 }
-                IndexReader reader = IndexReader.open(dirs[i]);
-                searchersList.add(new IndexSearcher(reader));
-            } catch (IOException e) {
-                LOG.error("cannot open index " + dirs[i], e);
             }
         }
 
@@ -572,16 +624,15 @@
     /**
      * Opens the searchers for the configured index Dirs after closing any already existing ones.
      */
-    protected synchronized void openSearchers()
+    protected synchronized void openSearchers(XWikiContext context)
     {
         try {
             closeSearchers(this.searchers);
-            this.searchers = createSearchers(indexDirs);
+            this.searchers = createSearchers(this.indexDirs, context);
         } catch (Exception e1) {
-            LOG.error("error opening searchers for index dirs "
-                + config.getProperty(PROP_INDEX_DIR), e1);
-            throw new RuntimeException("error opening searchers for index dirs "
-                + config.getProperty(PROP_INDEX_DIR), e1);
+            LOG.error("error opening searchers for index dirs " + config.getProperty(PROP_INDEX_DIR), e1);
+            throw new RuntimeException("error opening searchers for index dirs " + config.getProperty(PROP_INDEX_DIR),
+                e1);
         }
     }
 
@@ -601,27 +652,27 @@
 
     public String getIndexDirs()
     {
-        return indexDirs;
+        return this.indexDirs;
     }
 
     public long getQueueSize()
     {
-        return indexUpdater.getQueueSize();
+        return this.indexUpdater.getQueueSize();
     }
 
     public void queueDocument(XWikiDocument doc, XWikiContext context)
     {
-        indexUpdater.add(doc, context);
+        this.indexUpdater.add(doc, context);
     }
 
     public void queueAttachment(XWikiDocument doc, XWikiAttachment attach, XWikiContext context)
     {
-        indexUpdater.add(doc, attach, context);
+        this.indexUpdater.add(doc, attach, context);
     }
 
     public void queueAttachment(XWikiDocument doc, XWikiContext context)
     {
-        indexUpdater.addAttachmentsOfDocument(doc, context);
+        this.indexUpdater.addAttachmentsOfDocument(doc, context);
     }
 
     /**
@@ -629,14 +680,22 @@
      */
     public long getLuceneDocCount()
     {
-        return indexUpdater.getLuceneDocCount();
+        return this.indexUpdater.getLuceneDocCount();
     }
 
     /**
      * @return the number of documents in the second queue gave to Lucene.
      */
-    public long getActiveQueueSize()
+    // public long getActiveQueueSize()
+    // {
+    // return indexUpdater.getActiveQueueSize();
+    // }
+
+    /**
+     * Handle a corrupt index by clearing it and rebuilding from scratch.
+     */
+    void handleCorruptIndex(XWikiContext context) throws IOException
     {
-        return indexUpdater.getActiveQueueSize();
+        rebuildIndex(context);
     }
 }
Index: src/main/java/com/xpn/xwiki/plugin/lucene/IndexUpdater.java
===================================================================
--- src/main/java/com/xpn/xwiki/plugin/lucene/IndexUpdater.java	(revision 25374)
+++ src/main/java/com/xpn/xwiki/plugin/lucene/IndexUpdater.java	(working copy)
@@ -19,28 +19,23 @@
  */
 package com.xpn.xwiki.plugin.lucene;
 
-import java.io.File;
 import java.io.IOException;
 import java.util.ArrayList;
-import java.util.HashMap;
 import java.util.Iterator;
 import java.util.List;
-import java.util.Map;
-import java.util.Properties;
+import java.util.Random;
 
-import org.apache.commons.io.IOExceptionWithCause;
-import org.apache.commons.lang.StringUtils;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 import org.apache.log4j.MDC;
 import org.apache.lucene.analysis.Analyzer;
 import org.apache.lucene.document.Field;
-import org.apache.lucene.index.IndexReader;
+import org.apache.lucene.index.CorruptIndexException;
 import org.apache.lucene.index.IndexWriter;
-import org.apache.lucene.search.Hits;
+import org.apache.lucene.index.Term;
 import org.apache.lucene.search.IndexSearcher;
-import org.apache.lucene.search.Query;
-import org.apache.lucene.store.FSDirectory;
+import org.apache.lucene.store.Directory;
+import org.apache.lucene.store.LockObtainFailedException;
 import org.xwiki.observation.EventListener;
 import org.xwiki.observation.event.ActionExecutionEvent;
 import org.xwiki.observation.event.DocumentDeleteEvent;
@@ -77,7 +72,7 @@
     };
 
     /** Milliseconds of sleep between checks for changed documents. */
-    private int indexingInterval = 30000;
+    private final int indexingInterval;
 
     /** Milliseconds left till the next check for changed documents. */
     private int indexingTimer = 0;
@@ -88,11 +83,9 @@
      */
     private volatile boolean exit = false;
 
-    private IndexWriter writer;
-
-    private String indexDir;
+    private final Directory directory;
 
-    private XWikiDocumentQueue queue = new XWikiDocumentQueue();
+    private final XWikiDocumentQueue queue = new XWikiDocumentQueue();
 
     /**
      * Soft threshold after which no more documents will be added to the indexing queue. When the queue size gets larger
@@ -100,25 +93,29 @@
      * milliseconds until the queue size will get back bellow this threshold. This does not affect normal indexing
      * through wiki updates.
      */
-    public int maxQueueSize = 1000;
+    private final int maxQueueSize;
 
     private Analyzer analyzer;
 
-    private LucenePlugin plugin;
-
-    private IndexSearcher searcher;
-
-    private IndexReader reader;
+    private final LucenePlugin plugin;
 
     private XWikiContext context;
 
     private XWiki xwiki;
 
-    private long activesIndexedDocs = 0;
-
     static List<String> fields = new ArrayList<String>();
 
-    public boolean needInitialBuild = false;
+    IndexUpdater(Directory directory, int indexingInterval, int maxQueueSize, LucenePlugin plugin, XWikiContext context)
+    {
+        this.xwiki = context.getWiki();
+        this.context = (XWikiContext) context.clone();
+        this.context.setDatabase(this.context.getMainXWiki());
+        this.plugin = plugin;
+        this.directory = directory;
+
+        this.indexingInterval = indexingInterval;
+        this.maxQueueSize = maxQueueSize;
+    }
 
     public void doExit()
     {
@@ -126,6 +123,15 @@
     }
 
     /**
+     * Return a reference to the directory that this updater is currently working with.
+     */
+
+    public Directory getDirectory()
+    {
+        return directory;
+    }
+
+    /**
      * Main loop. Polls the queue for documents to be indexed.
      * 
      * @see java.lang.Runnable#run()
@@ -184,89 +190,47 @@
                 LOG.debug("IndexUpdater: documents in queue, start indexing");
             }
 
-            Map<String, IndexData> toIndex = new HashMap<String, IndexData>();
-            List<Integer> toDelete = new ArrayList<Integer>();
-            activesIndexedDocs = 0;
-
-            try {
-                openSearcher();
-                while (!this.queue.isEmpty()) {
-                    IndexData data = this.queue.remove();
-                    List<Integer> oldDocs = getOldIndexDocIds(data);
-                    if (oldDocs != null) {
-                        for (Integer id : oldDocs) {
-                            if (LOG.isDebugEnabled()) {
-                                LOG.debug("Adding " + id + " to remove list");
-                            }
+            XWikiContext context = (XWikiContext) this.context.clone();
+            context.getWiki().getStore().cleanUp(context);
 
-                            if (!toDelete.contains(id)) {
-                                toDelete.add(id);
-                            } else {
-                                if (LOG.isDebugEnabled()) {
-                                    LOG.debug("Found " + id + " already in list while adding it to remove list");
-                                }
-                            }
-                        }
-                    }
-
-                    String id = data.getId();
-                    LOG.debug("Adding " + id + " to index list");
-                    if (toIndex.containsKey(id)) {
-                        if (LOG.isDebugEnabled()) {
-                            LOG.debug("Found " + id + " already in list while adding it to index list");
-                        }
-                        toIndex.remove(id);
+            IndexSearcher searcher;
+            IndexWriter writer;
+            RETRY: while (true) {
+                // We will retry after repairing if the index was
+                // corrupt
+                try {
+                    try {
+                        searcher = new IndexSearcher(directory, true);
+                        writer = openWriter(false);
+                        break RETRY;
+                    } catch (CorruptIndexException e) {
+                        plugin.handleCorruptIndex(context);
                     }
-                    ++activesIndexedDocs;
-                    toIndex.put(id, data);
-                }
-            } catch (Exception e) {
-                LOG.error("error preparing index queue", e);
-            } finally {
-                closeSearcher();
-            }
-
-            // Let's delete
-            try {
-                openSearcher();
-                if (LOG.isInfoEnabled()) {
-                    LOG.info("deleting " + toDelete.size() + " docs from lucene index");
-                }
-                int nb = deleteOldDocs(toDelete);
-                if (LOG.isInfoEnabled()) {
-                    LOG.info("deleted " + nb + " docs from lucene index");
+                } catch (IOException e) {
+                    LOG.error("Failed to open index");
+                    throw new RuntimeException(e);
                 }
-            } catch (Exception e) {
-                LOG.error("error deleting previous documents", e);
-            } finally {
-                closeSearcher();
             }
 
-            // Let's index
             try {
-                if (LOG.isInfoEnabled()) {
-                    LOG.info("indexing " + toIndex.size() + " docs to lucene index");
-                }
-
-                XWikiContext context = (XWikiContext) this.context.clone();
-                context.getWiki().getStore().cleanUp(context);
-                openWriter(false);
-
                 int nb = 0;
-                for (Map.Entry<String, IndexData> entry : toIndex.entrySet()) {
-                    String id = entry.getKey();
-                    IndexData data = entry.getValue();
+                while (!this.queue.isEmpty()) {
+                    IndexData data = this.queue.remove();
+
+                    String id = data.getId();
 
                     try {
+                        /*
+                         * XXX Is it not possible to obtain the right translation directly?
+                         */
                         XWikiDocument doc = this.xwiki.getDocument(data.getFullName(), context);
 
                         if (data.getLanguage() != null && !data.getLanguage().equals("")) {
                             doc = doc.getTranslatedDocument(data.getLanguage(), context);
                         }
 
-                        addToIndex(data, doc, context);
+                        addToIndex(writer, searcher, data, doc, context);
                         ++nb;
-                        --activesIndexedDocs;
                     } catch (Exception e) {
                         LOG.error("error indexing document " + id, e);
                     }
@@ -276,136 +240,49 @@
                     LOG.info("indexed " + nb + " docs to lucene index");
                 }
 
-                writer.flush();
+                writer.commit();
             } catch (Exception e) {
                 LOG.error("error indexing documents", e);
             } finally {
                 this.context.getWiki().getStore().cleanUp(this.context);
-                closeWriter();
-            }
-
-            plugin.openSearchers();
-        }
-    }
-
-    private synchronized void closeSearcher()
-    {
-        try {
-            if (this.searcher != null) {
-                this.searcher.close();
-            }
-            if (this.reader != null) {
-                this.reader.close();
+                try {
+                    searcher.close();
+                } catch (IOException e) {
+                    LOG.warn("Failed to close searcher.");
+                }
+                try {
+                    writer.optimize();
+                    writer.close();
+                } catch (IOException e) {
+                    LOG.warn("Failed to close writer.");
+                }
             }
-        } catch (IOException e) {
-            LOG.error("error closing index searcher", e);
-        } finally {
-            this.searcher = null;
-            this.reader = null;
-        }
-    }
 
-    /**
-     * Opens the index reader and searcher used for finding and deleting old versions of indexed documents.
-     */
-    private synchronized void openSearcher()
-    {
-        try {
-            this.reader = IndexReader.open(this.indexDir);
-            this.searcher = new IndexSearcher(this.reader);
-        } catch (IOException e) {
-            LOG.error("error opening index searcher", e);
+            this.plugin.openSearchers(context);
         }
     }
 
-    /**
-     * Deletes the documents with the given ids from the index.
-     */
-    private int deleteOldDocs(List<Integer> oldDocs)
+    protected IndexWriter openWriter(boolean create) throws IOException
     {
-        int nb = 0;
-
-        for (Integer id : oldDocs) {
-            if (LOG.isDebugEnabled()) {
-                LOG.debug("delete doc " + id);
-            }
-
+        while (true) {
             try {
-                this.reader.deleteDocument(id);
-                nb++;
-            } catch (IOException e1) {
-                LOG.error("error deleting doc " + id, e1);
-            }
-        }
-
-        return nb;
-    }
-
-    private List<Integer> getOldIndexDocIds(IndexData data)
-    {
-        List<Integer> retval = new ArrayList<Integer>(3);
-        Query query = data.buildQuery();
-        try {
-            Hits hits = this.searcher.search(query);
-            for (int i = 0; i < hits.length(); i++) {
-                retval.add(new Integer(hits.id(i)));
-            }
-        } catch (Exception e) {
-            LOG.error(String.format("Error looking for old versions of document [%s] with query [%s]", data, query), e);
-        }
+                IndexWriter w = new IndexWriter(directory, analyzer, create, IndexWriter.MaxFieldLength.LIMITED);
+                w.setUseCompoundFile(true);
 
-        return retval;
-    }
-
-    private void openWriter(boolean create) throws IOException
-    {
-        if (writer != null) {
-            LOG.error("Writer already open and createWriter called");
-            return;
-        }
-
-        try {
-            // fix for windows by Daniel Cortes:
-            FSDirectory f = FSDirectory.getDirectory(indexDir);
-            writer = new IndexWriter(f, analyzer, create);
-            // writer = new IndexWriter (indexDir, analyzer, create);
-            writer.setUseCompoundFile(true);
-
-            if (LOG.isDebugEnabled()) {
-                LOG.debug("successfully opened index writer : " + indexDir);
+                return w;
+            } catch (LockObtainFailedException e) {
+                try {
+                    int s = new Random().nextInt(1000);
+                    LOG.debug("failed to acquire lock, retrying in " + s + "ms ...");
+                    Thread.sleep(s);
+                } catch (InterruptedException e0) {
+                }
             }
-        } catch (IOException e) {
-            throw new IOExceptionWithCause("Error opening Lucene Index for writing at " + indexDir, e);
-        }
-    }
-
-    private void closeWriter()
-    {
-        if (this.writer == null) {
-            LOG.error("Writer not open and closeWriter called");
-            return;
-        }
-
-        try {
-            this.writer.optimize();
-        } catch (IOException e1) {
-            LOG.error("Exception caught when optimizing Index", e1);
-        }
-
-        try {
-            this.writer.close();
-        } catch (Exception e) {
-            LOG.error("Exception caught when closing IndexWriter", e);
-        }
-
-        this.writer = null;
-
-        if (LOG.isDebugEnabled()) {
-            LOG.debug("closed writer.");
         }
     }
 
-    private void addToIndex(IndexData data, XWikiDocument doc, XWikiContext context) throws IOException
+    private void addToIndex(IndexWriter writer, IndexSearcher searcher, IndexData data, XWikiDocument doc,
+        XWikiContext context) throws IOException
     {
         if (LOG.isDebugEnabled()) {
             LOG.debug("addToIndex: " + data);
@@ -423,16 +300,16 @@
             }
         }
 
-        this.writer.addDocument(luceneDoc);
+        writer.updateDocument(new Term(IndexFields.DOCUMENT_ID, data.getId()), luceneDoc);
     }
 
-    /**
-     * @param indexDir The indexDir to set.
-     */
-    public void setIndexDir(String indexDir)
-    {
-        this.indexDir = indexDir;
-    }
+    // /**
+    // * @param indexDir The indexDir to set.
+    // */
+    // public void setIndexDir(String indexDir)
+    // {
+    // this.indexDir = indexDir;
+    // }
 
     /**
      * @param analyzer The analyzer to set.
@@ -442,58 +319,16 @@
         this.analyzer = analyzer;
     }
 
-    public synchronized void init(Properties config, LucenePlugin plugin, XWikiContext context)
-    {
-        this.xwiki = context.getWiki();
-        this.context = (XWikiContext) context.clone();
-        this.context.setDatabase(this.context.getMainXWiki());
-        this.plugin = plugin;
-        // take the first configured index dir as the one for writing
-        // String[] indexDirs =
-        // StringUtils.split(config.getProperty(LucenePlugin.PROP_INDEX_DIR), "
-        // ,");
-        String[] indexDirs = StringUtils.split(plugin.getIndexDirs(), ",");
-        if (indexDirs != null && indexDirs.length > 0) {
-            this.indexDir = indexDirs[0];
-            File f = new File(indexDir);
-            if (!f.isDirectory()) {
-                f.mkdirs();
-                this.needInitialBuild = true;
-            }
-            if (!IndexReader.indexExists(f)) {
-                this.needInitialBuild = true;
-            }
-        }
-
-        this.indexingInterval = 1000 * Integer.parseInt(config.getProperty(LucenePlugin.PROP_INDEXING_INTERVAL, "30"));
-        this.maxQueueSize = Integer.parseInt(config.getProperty(LucenePlugin.PROP_MAX_QUEUE_SIZE, "1000"));
-
-        // Note: There's no need to open the Searcher here (with a call to
-        // openSearcher()) as each task needing it will open it itself.
-    }
-
     public void cleanIndex() throws IOException
     {
         if (LOG.isInfoEnabled()) {
             LOG.info("trying to clear index for rebuilding");
         }
 
-        while (writer != null) {
-            if (LOG.isDebugEnabled()) {
-                LOG.debug("waiting for existing index writer to close");
-            }
-
-            try {
-                Thread.sleep(1000);
-            } catch (InterruptedException e) {
-                // TODO Auto-generated catch block
-                e.printStackTrace();
-            }
-        }
-
-        synchronized (this) {
-            openWriter(true);
-            closeWriter();
+        try {
+            openWriter(true).close();
+        } catch (IOException e) {
+            LOG.error("Failed to clean index: " + e);
         }
     }
 
@@ -501,14 +336,6 @@
     {
         this.queue.add(new DocumentData(document, context));
 
-        if (document.hasElement(XWikiDocument.HAS_OBJECTS)) {
-            addObject(document, context);
-        }
-    }
-
-    public void addObject(XWikiDocument document, XWikiContext context)
-    {
-        this.queue.add(new ObjectData(document, context));
     }
 
     public void add(XWikiDocument document, XWikiAttachment attachment, XWikiContext context)
@@ -562,7 +389,10 @@
                 // Retrieve the latest version (with the file just attached)
                 XWikiDocument basedoc = context.getWiki().getDocument(document.getFullName(), context);
                 List<XWikiAttachment> attachments = basedoc.getAttachmentList();
-                // find out the most recently changed attachment
+                /*
+                 * XXX Race condition: if two or more attachments are added before we find the "newest attachment"
+                 * below, only the last one added will be indexed.
+                 */
                 XWikiAttachment newestAttachment = null;
                 for (XWikiAttachment attachment : attachments) {
                     if ((newestAttachment == null) || attachment.getDate().after(newestAttachment.getDate())) {
@@ -597,17 +427,19 @@
      */
     public long getLuceneDocCount()
     {
-        if (writer != null)
-            return writer.docCount();
+        try {
+            IndexWriter w = openWriter(false);
+            long n = w.docCount();
+            w.close();
+        } catch (IOException e) {
+        }
 
         return -1;
     }
 
-    /**
-     * @return the number of documents in the second queue gave to Lucene.
-     */
-    public long getActiveQueueSize()
+    public int getMaxQueueSize()
     {
-        return this.activesIndexedDocs;
+        return maxQueueSize;
     }
+
 }
